diff --git a/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx b/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx
index 1ab9716e..decc3b4 100644
--- a/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx
+++ b/src/BRepTopAdaptor/BRepTopAdaptor_FClass2d.cxx
@@ -25,743 +22,1090 @@
 #include <BRepAdaptor_HSurface.hxx>
 #include <BRepClass_FaceClassifier.hxx>
 #include <BRepTools_WireExplorer.hxx>
-#include <BRepTopAdaptor_FClass2d.hxx>
 #include <CSLib_Class2d.hxx>
 #include <ElCLib.hxx>
-#include <Geom2dInt_Geom2dCurveTool.hxx>
-#include <GeomAbs_SurfaceType.hxx>
 #include <GCPnts_QuasiUniformDeflection.hxx>
-#include <gp_Pnt.hxx>
-#include <gp_Pnt2d.hxx>
+#include <Geom2d_Curve.hxx>
+#include <Geom2dInt_Geom2dCurveTool.hxx>
+#include <GeomInt.hxx>
 #include <Precision.hxx>
-#include <TColgp_Array1OfPnt2d.hxx>
 #include <TColgp_SequenceOfPnt2d.hxx>
-#include <TopAbs_Orientation.hxx>
+#include <TColgp_SequenceOfVec2d.hxx>
+#include <TColStd_DataMapOfIntegerInteger.hxx>
 #include <TopExp.hxx>
 #include <TopExp_Explorer.hxx>
 #include <TopoDS.hxx>
 #include <TopoDS_Edge.hxx>
-#include <TopoDS_Face.hxx>
-
-#ifdef _MSC_VER
-#include <stdio.h>
-#endif
+#include <TopoDS_Vertex.hxx>
+#include <TopoDS_Wire.hxx>
 
+#include <NCollection_UBTree.hxx>
+#include <NCollection_UBTreeFiller.hxx>
+#include <Bnd_B2d.hxx>
 
-#ifdef OCCT_DEBUG
-#define LBRCOMPT 0
-#else
-#define LBRCOMPT 0
+//#define DEBUG_PCLASS_POLYGON
+#ifdef DEBUG_PCLASS_POLYGON
+#include <DrawTrSurf.hxx>
+#include <Geom2d_BSplineCurve.hxx>
 #endif
 
+typedef NCollection_UBTree<Standard_Integer, Bnd_B2d> BRepTopAdaptor_FClass2dTree;
+typedef NCollection_UBTreeFiller <Standard_Integer, Bnd_B2d> BRepTopAdaptor_FClass2dTreeFiller;
 
-#if LBRCOMPT  
-class StatistiquesFClass2d { 
-public:
-  long unsigned NbConstrShape;
-  long unsigned NbPerformInfinitePoint;
-  long unsigned NbPerform;
-  long unsigned NbTestOnRestriction;
-  long unsigned NbDestroy;
+inline Standard_Boolean IsInter1d(Standard_Real theU1, Standard_Real theU2,
+                                  Standard_Real theW1, Standard_Real theW2)
+{
+  if (theU1 > theU2)  std::swap(theU1, theU2);
+  if (theW1 > theW2)  std::swap(theW1, theW2);
+  return Max(theU1, theW1) - Min(theU2, theW2) < Precision::PConfusion();
+}
+
+class BRepTopAdaptor_FClass2dSel : public BRepTopAdaptor_FClass2dTree::Selector
+{
 public:
-  StatistiquesFClass2d() { 
-    NbConstrShape=NbPerform=NbPerformInfinitePoint=NbDestroy=0;
+  BRepTopAdaptor_FClass2dSel(const TColgp_Array1OfPnt2d& thePnts,
+                             const Bnd_B2d& theBox,
+                             const Standard_Integer theCurIdx) : 
+                             myPnts(thePnts),
+                             myBox(theBox),
+                             myNbSeg(myPnts.Length() - 1),
+                             myCurrentIndex(theCurIdx),
+                             myP1(myPnts(myCurrentIndex).XY()),
+                             myP2(myPnts(myCurrentIndex + 1).XY()),
+                             myVec12(myP2 - myP1)
+  {}
+
+  Standard_Boolean Reject(const Bnd_B2d& theBox) const
+  {
+    return theBox.IsOut(myBox);
   }
-  ~StatistiquesFClass2d() { 
-    printf("\n--- Statistiques BRepTopAdaptor:\n");
-    printf("\nConstructeur(Shape) : %10lu",NbConstrShape);
-    printf("\nPerformInfinitePoint: %10lu",NbPerformInfinitePoint);
-    printf("\nTestOnRestriction   : %10lu",NbTestOnRestriction);
-    printf("\nPerform(pnt2d)      : %10lu",NbPerform);
-    printf("\nDestroy             : %10lu",NbDestroy);
+
+  Standard_Boolean Accept(const Standard_Integer& theIndex)
+  {
+    // reject the same or neighboring index
+    if (myCurrentIndex == theIndex)
+      return Standard_False;
+    if ((myCurrentIndex % myNbSeg) + 1 == theIndex || (theIndex % myNbSeg) + 1 == myCurrentIndex)
+      return Standard_False;
+
+    const gp_XY& aP3 = myPnts(theIndex).XY();
+    const gp_XY& aP4 = myPnts(theIndex + 1).XY();
+
+    if (IsInter1d(myP1.X(), myP2.X(), aP3.X(), aP4.X()) &&
+        IsInter1d(myP1.Y(), myP2.Y(), aP3.Y(), aP4.Y()))
+    {
+      Standard_Real anAreaEps = Precision::PConfusion() * Precision::PConfusion();
+      gp_XY aVec13 = aP3 - myP1;
+      gp_XY aVec14 = aP4 - myP1;
+      if (myVec12.Crossed(aVec13) * myVec12.Crossed(aVec14) < anAreaEps)
+      {
+        gp_XY aVec34 = aP4 - aP3;
+        gp_XY aVec32 = myP2 - aP3;
+        if (aVec13.Crossed(aVec14) * aVec34.Crossed(aVec32) < anAreaEps)
+        {
+          myStop = Standard_True;
+          return Standard_True;
+        }
+      }
+    }
+    return Standard_False;
   }
-};
 
-static StatistiquesFClass2d STAT;
-#endif
+protected:
+  BRepTopAdaptor_FClass2dSel(BRepTopAdaptor_FClass2dSel&);
+  const BRepTopAdaptor_FClass2dSel& operator=(const BRepTopAdaptor_FClass2dSel&);
 
+private:
+  const TColgp_Array1OfPnt2d& myPnts;
+  Bnd_B2d myBox;
+  Standard_Integer myNbSeg, myCurrentIndex;
+  gp_XY myP1, myP2, myVec12;
+};
 
 
+//=======================================================================
+//function : Default constructor
+//purpose  : 
+//=======================================================================
+BRepTopAdaptor_FClass2d::BRepTopAdaptor_FClass2d() : myTol3D(Precision::Confusion()),
+                                                     myUmin(RealLast()),
+                                                     myVmin(RealLast()),
+                                                     myUmax(-myUmin),
+                                                     myVmax(-myVmin)
+{
+}
 
-BRepTopAdaptor_FClass2d::BRepTopAdaptor_FClass2d(const TopoDS_Face& aFace,const Standard_Real TolUV) 
-: Toluv(TolUV), Face(aFace)  { 
-  
-#if LBRCOMPT 
-  STAT.NbConstrShape++;
-#endif
+//=======================================================================
+//function : Constructor
+//purpose  : 
+//=======================================================================
+BRepTopAdaptor_FClass2d::BRepTopAdaptor_FClass2d(const TopoDS_Face& theFace,
+                                                 const Standard_Real theTol3D):
+                                                 myFace(theFace),
+                                                 myTol3D(theTol3D),
+                                                 myUmin(RealLast()), myVmin(RealLast()),
+                                                 myUmax(-myUmin), myVmax(-myVmin)
+{
+  Init(myFace, theTol3D);
+}
 
-  //-- dead end on surfaces defined on more than one period
+//=======================================================================
+//function : ComputeDeviation
+//purpose  : 
+//=======================================================================
+static Standard_Boolean ComputeDeviation(const gp_Pnt2d& thePf,
+                                         const gp_Pnt2d& thePl,
+                                         const gp_Pnt2d& thePm,
+                                         Standard_Real& theDU, Standard_Real& theDV)
+{
+  const gp_XY aDirVec = thePl.XY() - thePf.XY();
 
-  Face.Orientation(TopAbs_FORWARD);
-  Handle(BRepAdaptor_HSurface) surf = new BRepAdaptor_HSurface();
-  surf->ChangeSurface().Initialize(aFace,Standard_False);
-  
+  if (aDirVec.SquareModulus() > 1.0e-16)
+  {
+    const gp_Lin2d aLin(thePf, gp_Dir2d(aDirVec));
+    const Standard_Real aUmid = ElCLib::Parameter(aLin, thePm);
+    const gp_Pnt2d aPp = ElCLib::Value(aUmid, aLin);
+    theDU = Abs(aPp.X() - thePm.X());
+    theDV = Abs(aPp.Y() - thePm.Y());
+    return Standard_True;
+  }
+  return Standard_False;
+}
+
+//=======================================================================
+//function : Init
+//purpose  : 
+//=======================================================================
+void BRepTopAdaptor_FClass2d::Init(const TopoDS_Face& theFace,
+                                   const Standard_Real theTol3D)
+{
+  Standard_Boolean WireIsEmpty, Ancienpnt3dinitialise, degenerated;
+  Standard_Integer nbpnts, firstpoint, NbEdges;
+  Standard_Integer iX, aNbs1, nbs, Avant, BadWire;
+  Standard_Real u, du, pfbid, plbid;
+  Standard_Real FlecheU, FlecheV;
+  Standard_Real uFirst, uLast;
+  Standard_Real aPrCf, aPrCf2;
+  //
   TopoDS_Edge  edge;
+  TopoDS_Vertex Va, Vb;
   TopAbs_Orientation Or;
-  Standard_Real u,du,Tole = 0.0,Tol=0.0;
-  BRepTools_WireExplorer WireExplorer;
-  TopExp_Explorer FaceExplorer;
+  BRepTools_WireExplorer aWExp;
+  TopExp_Explorer aExpF, aExp;
+  Handle(Geom2d_Curve) aC2D;
+  gp_Pnt Ancienpnt3d;
+  TColgp_SequenceOfPnt2d SeqPnt2d;
+  
+  BRepAdaptor_Surface anAS(theFace, Standard_False);
+
+  Destroy();
 
-  Umin = Vmin = 0.0; //RealLast();
-  Umax = Vmax = -Umin;
+  aPrCf = Precision::Confusion();
+  aPrCf2 = aPrCf*aPrCf;
+  //
+  myFace = theFace;
+  myFace.Orientation(TopAbs_FORWARD);
+  myTol3D = theTol3D;
+  const Standard_Real aTolU = anAS.UResolution(theTol3D),
+                      aTolV = anAS.VResolution(theTol3D);
+  //const Standard_Real aMaxGapU = Max(aTolU, Precision::PConfusion());
+  //const Standard_Real aMaxGapV = Max(aTolV, Precision::PConfusion());
+  //
+  myUmin = myVmin = RealLast();
+  myUmax = myVmax = -myUmin;
+  BadWire = 0;
 
-  Standard_Integer BadWire=0;
-  for( FaceExplorer.Init(Face,TopAbs_WIRE); (FaceExplorer.More() && BadWire==0); FaceExplorer.Next() )
+  //if face has several wires and one of them is bad,
+  //it is necessary to process all of them for correct
+  //calculation of Umin, Umax, Vmin, Vmax - ifv, 23.08.06 
+  //
+  aExpF.Init(myFace, TopAbs_WIRE);
+  for (; aExpF.More(); aExpF.Next())
+  {
+    const TopoDS_Wire& aW = *((TopoDS_Wire*)&aExpF.Current());
+    //
+    nbpnts = 0;
+    firstpoint = 1;
+    FlecheU = aTolU;
+    FlecheV = aTolV;
+    WireIsEmpty = Standard_True;
+    Ancienpnt3dinitialise = Standard_False;
+    Ancienpnt3d.SetCoord(0., 0., 0.);
+    //
+    SeqPnt2d.Clear();
+    //
+    // NbEdges
+    NbEdges = 0;
+    aExp.Init(aW, TopAbs_EDGE);
+    for (; aExp.More(); aExp.Next())
     {
-      Standard_Integer nbpnts = 0;
-      TColgp_SequenceOfPnt2d SeqPnt2d;
-      Standard_Integer firstpoint = 1;
-      Standard_Real FlecheU = 0.0;
-      Standard_Real FlecheV = 0.0;
-      Standard_Boolean WireIsNotEmpty = Standard_False;
-      Standard_Integer NbEdges = 0;
-
-      TopExp_Explorer Explorer;
-      for( Explorer.Init(FaceExplorer.Current(),TopAbs_EDGE); Explorer.More(); Explorer.Next() ) NbEdges++;
-        
-      gp_Pnt Ancienpnt3d(0,0,0);
-      Standard_Boolean Ancienpnt3dinitialise = Standard_False;
-
-      for( WireExplorer.Init(TopoDS::Wire(FaceExplorer.Current()),Face); WireExplorer.More(); WireExplorer.Next() )
-	{
-	  
-	  NbEdges--;
-	  edge = WireExplorer.Current();
-	  Or = edge.Orientation();
-	  if(Or == TopAbs_FORWARD || Or == TopAbs_REVERSED)
-	    {
-	      Standard_Real pfbid,plbid;
-	      if(BRep_Tool::CurveOnSurface(edge,Face,pfbid,plbid).IsNull()) return;
-	      BRepAdaptor_Curve2d C(edge,Face);
-	
-	      //-- ----------------------------------------
-	      Standard_Boolean degenerated=Standard_False;
-	      if(BRep_Tool::Degenerated(edge))   degenerated=Standard_True;
-	      if(BRep_Tool::IsClosed(edge,Face)) degenerated=Standard_True;
-	      TopoDS_Vertex Va,Vb;
-	      TopExp::Vertices(edge,Va,Vb);
-	      Standard_Real TolVertex1=0.,TolVertex=0.;
-	      if (Va.IsNull()) degenerated=Standard_True;
-	      else TolVertex1=BRep_Tool::Tolerance(Va);
-	      if (Vb.IsNull()) degenerated=Standard_True;
-	      else TolVertex=BRep_Tool::Tolerance(Vb);
-	      if(TolVertex<TolVertex1) TolVertex=TolVertex1;
-	      BRepAdaptor_Curve C3d;
-	
-	      if(Abs(plbid-pfbid) < 1.e-9) continue;
-
-	      //if(degenerated==Standard_False)
-	      //  C3d.Initialize(edge,Face);
-
-	      //-- Check cases when it was forgotten to code degenerated :  PRO17410 (janv 99)
-	      if(degenerated == Standard_False)
-		{
-		  C3d.Initialize(edge,Face);
-		  du=(plbid-pfbid)*0.1;
-		  u=pfbid+du;
-		  gp_Pnt P3da=C3d.Value(u);
-		  degenerated=Standard_True;
-		  u+=du;
-		  do
-		    {
-		      
-		      gp_Pnt P3db=C3d.Value(u);
-		      // 		      if(P3da.SquareDistance(P3db)) { degenerated=Standard_False; break; }
-		      if(P3da.SquareDistance(P3db) > Precision::Confusion()) { degenerated=Standard_False; break; }
-		      u+=du;
-		    }
-		  while(u<plbid);
-		}
-	      
-	      //-- ----------------------------------------
-
-	      Tole = BRep_Tool::Tolerance(edge);
-	      if(Tole>Tol) Tol=Tole;
-	      
-	      //Standard_Integer nbs = 1 + Geom2dInt_Geom2dCurveTool::NbSamples(C);
-	      Standard_Integer nbs = Geom2dInt_Geom2dCurveTool::NbSamples(C);
-	      //-- Attention to rational bsplines of degree 3. (ends of circles among others)
-	      if (nbs > 2) nbs*=4;
-	      du = (plbid-pfbid)/(Standard_Real)(nbs-1);
-
-	      if(Or==TopAbs_FORWARD) u = pfbid;
-	      else { u = plbid; du=-du;	}
-	
-	      //-- ------------------------------------------------------------
-	      //-- Check distance uv between the start point of the edge
-	      //-- and the last point registered in SeqPnt2d
-	      //-- Try to remote the first point of the current edge 
-	      //-- from the last saved point
-#ifdef OCCT_DEBUG
-	      gp_Pnt2d Pnt2dDebutEdgeCourant = C.Value(u); (void)Pnt2dDebutEdgeCourant;
-#endif
+      const TopoDS_Edge& anE = TopoDS::Edge(aExp.Current());
+      const Standard_Real aTol = BRep_Tool::Tolerance(anE);
+      FlecheU = Max(FlecheU, anAS.UResolution(aTol));
+      FlecheV = Max(FlecheV, anAS.VResolution(aTol));
+      NbEdges++;
+    }
+
+    // First and last points of the previous edges
+    // in order to detect if wire is close in 2d-space
+    //gp_Pnt2d aPrevPoint, aFirstEPoint;
+    //Standard_Boolean isFirst = Standard_True;
+
+    //
+    aWExp.Init(aW, myFace);
+    for (; aWExp.More(); aWExp.Next()) {
+      NbEdges--;
+      edge = aWExp.Current();
+      Or = edge.Orientation();
+      if (!(Or == TopAbs_FORWARD || Or == TopAbs_REVERSED)) {
+        continue;
+      }
+      //
+      aC2D = BRep_Tool::CurveOnSurface(edge, myFace, pfbid, plbid);
+      if (aC2D.IsNull()) {
+        return;
+      }
+      //
+      BRepAdaptor_Curve2d C(edge, myFace);
+
+      //if (isFirst)
+      //{
+      //  C.D0(C.FirstParameter(), aFirstEPoint);
+      //  C.D0(C.LastParameter(), aPrevPoint);
+
+      //  if (edge.Orientation() == TopAbs_REVERSED)
+      //    std::swap(aFirstEPoint, aPrevPoint);
+      //}
+      //else
+      //{
+      //  gp_Pnt2d aP1(C.Value((Or == TopAbs_REVERSED) ? C.LastParameter() : C.FirstParameter()));
+      //  if (Abs(aP1.X() - aPrevPoint.X()) > aMaxGapU || Abs(aP1.Y() - aPrevPoint.Y()) > aMaxGapV)
+      //  {
+      //    //Wire is not closed in 2D-space
+      //    BadWire = 1;
+      //  }
+
+      //  C.D0((Or == TopAbs_REVERSED) ? C.FirstParameter() : C.LastParameter(), aPrevPoint);
+      //}
+
+      //isFirst = Standard_False;
+
+      BRepAdaptor_Curve C3d;
+      //------------------------------------------
+      degenerated = Standard_False;
+      if (BRep_Tool::Degenerated(edge) ||
+          BRep_Tool::IsClosed(edge, myFace))
+      {
+        degenerated = Standard_True;
+      }
+      //
+      TopExp::Vertices(edge, Va, Vb);
+      //
+      if (Va.IsNull() || Vb.IsNull())
+      {
+        degenerated = Standard_True;
+      }
+      //
+      //-- Verification of cases when forgotten to code degenereted
+      if (!degenerated) {
+        // check that whole curve is located in vicinity of its middle point
+        // (within sphere of Precision::Confusion() diameter)
+        C3d.Initialize(edge, myFace);
+        gp_Pnt P3da = C3d.Value(0.5 * (pfbid + plbid));
+        du = plbid - pfbid;
+        const int NBSTEPS = 10;
+        Standard_Real aPrec2 = 0.25 * Precision::Confusion() * Precision::Confusion();
+        degenerated = Standard_True;
+        for (Standard_Integer i = 0; i <= NBSTEPS; i++)
+        {
+          Standard_Real U = pfbid + i * du / NBSTEPS;
+          gp_Pnt P3db = C3d.Value(U);
+          Standard_Real aR2 = P3da.SquareDistance(P3db);
+          if (aR2 > aPrec2) {
+            degenerated = Standard_False;
+            break;
+          }
+        }
+      }//if(!degenerated)
+      //-- ----------------------------------------
+      //
+      // NbSamples +> nbs
+      nbs = Geom2dInt_Geom2dCurveTool::NbSamples(C);
+      if (nbs > 2) {
+        nbs *= 4;
+      }
+      du = (plbid - pfbid) / (Standard_Real)(nbs - 1);
+      //
+      if (Or == TopAbs_FORWARD) {
+        u = pfbid;
+        uFirst = pfbid;
+        uLast = plbid;
+      }
+      else {
+        u = plbid;
+        uFirst = plbid;
+        uLast = pfbid;
+        du = -du;
+      }
+      //
+      // aPrms
+      aNbs1 = (nbs == 2 ? nbs + 1 : nbs);
+      TColStd_Array1OfReal aPrms(1, aNbs1);
+      //
+      if (nbs == 2) {
+        Standard_Real aCoef = 0.0025;
+        aPrms(1) = uFirst;
+        aPrms(2) = uFirst + aCoef*(uLast - uFirst);
+        aPrms(3) = uLast;
+      }
+      else if (nbs>2) {
+        aNbs1 = nbs;
+        aPrms(1) = uFirst;
+        for (iX = 2; iX<aNbs1; ++iX) {
+          aPrms(iX) = u + (iX - 1)*du;
+        }
+        aPrms(aNbs1) = uLast;
+      }
+      //
+      //-- ------------------------------------------------------------
+      //-- Check distance uv between the start point of the edge
+      //-- and the last point saved in SeqPnt2d
+      //-- To to set the first point of the current 
+      //-- afar from the last saved point
+      Avant = nbpnts;
+      for (iX = firstpoint; iX <= aNbs1; iX++) {
+        Standard_Boolean IsRealCurve3d;
+        Standard_Integer ii;
+        Standard_Real aDstX;
+        gp_Pnt2d P2d;
+        gp_Pnt P3d;
+        //
+        u = aPrms(iX);
+        P2d = C.Value(u);
+        if(P2d.X()<myUmin) myUmin = P2d.X();
+        if(P2d.X()>myUmax) myUmax = P2d.X();
+        if(P2d.Y()<myVmin) myVmin = P2d.Y();
+        if(P2d.Y()>myVmax) myVmax = P2d.Y();
+        //
+        aDstX = RealLast();
+        if (degenerated == Standard_False) {
+          P3d = C3d.Value(u);
+          if (nbpnts>1) {
+            if (Ancienpnt3dinitialise) {
+              aDstX = P3d.SquareDistance(Ancienpnt3d);
+            }
+          }
+        }
+        //
+        IsRealCurve3d = Standard_True;
+        if (aDstX < aPrCf2)  {
+          if (iX>1) {
+            Standard_Real aDstX1;
+            gp_Pnt MidP3d;
+            //
+            MidP3d = C3d.Value(0.5*(u + aPrms(iX - 1)));
+            aDstX1 = P3d.SquareDistance(MidP3d);
+            if (aDstX1 < aPrCf2){
+              IsRealCurve3d = Standard_False;
+            }
+          }
+        }
+        //
+        if (IsRealCurve3d) {
+          if (degenerated == Standard_False) {
+            Ancienpnt3d = P3d;
+            Ancienpnt3dinitialise = Standard_True;
+          }
+          nbpnts++;
+          SeqPnt2d.Append(P2d);
+        }
+        //
+        ii = nbpnts;
+        if (ii>(Avant + 4)) {
+          const gp_Pnt2d &aPpf = SeqPnt2d(ii - 2),
+                         &aPpl = SeqPnt2d(ii),
+                         &aPpm = SeqPnt2d(ii - 1);
+          Standard_Real aDU, aDV;
+          if (ComputeDeviation(aPpf, aPpl, aPpm, aDU, aDV))
+          {
+            if (aDU > FlecheU)
+              FlecheU = aDU;
+            if (aDV > FlecheV)
+              FlecheV = aDV;
+          }
+        }
+        else if (firstpoint == 2 && iX == 2)
+        {
+          // compute deflection of skipped beginning of the curve to the created polygon
+          const gp_Pnt2d &aPpf = SeqPnt2d(ii - 1),
+                         &aPpl = SeqPnt2d(ii);
+          const gp_Pnt2d aPpm = C.Value(aPrms(1));
+          Standard_Real aDU, aDV;
+          if (ComputeDeviation(aPpf, aPpl, aPpm, aDU, aDV))
+          {
+            if (aDU > FlecheU)
+              FlecheU = aDU;
+            if (aDV > FlecheV)
+              FlecheV = aDV;
+          }
+        }
+      }// for(iX=firstpoint; iX<=aNbs1; iX++) {
+      //
+      if (BadWire) {
+        continue; //if face has several wires and one of them is bad,
+        //it is necessary to process all of them for correct
+        //calculation of Umin, Umax, Vmin, Vmax - ifv, 23.08.06 
+      }
+      //
+      if (firstpoint == 1)
+        firstpoint = 2;
+
+      WireIsEmpty = Standard_False;
+    } //for(;aWExp.More(); aWExp.Next()) {
+    // ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+    if (NbEdges/* || Abs(aFirstEPoint.X() - aPrevPoint.X()) > aMaxGapU ||
+                   Abs(aFirstEPoint.Y() - aPrevPoint.Y()) > aMaxGapV*/)
+    {
+      // 1. TopExp_Explorer and BRepTools_WireExplorer returns differ number of edges
+      // 2. Wire is not closed in 2D-space
+      TColgp_Array1OfPnt2d PClass(1, 2);
+      gp_Pnt2d anInitPnt(0., 0.);
+      //
+      PClass.Init(anInitPnt);
+      myTabClass.Append(new CSLib_Class2d(PClass,
+                                          FlecheU,
+                                          FlecheV,
+                                          myUmin, myVmin, myUmax, myVmax));
+      BadWire = 1;
+      myTabOrien.Append(-1);
+    }
+    //
+    else if (!WireIsEmpty)
+    {
+      Standard_Real anArea = 0.0;
+      TColgp_Array1OfPnt2d PClass(1, nbpnts);
+      gp_Pnt2d anInitPnt(0., 0.);
+      //
+      PClass.Init(anInitPnt);
+      if (nbpnts <= 3)
+      {
+        BadWire = 1;
+      }
+      
+      if (!BadWire)
+      {
+        // Point to area computation
+        const Standard_Integer im2 = nbpnts - 2;
+        Standard_Integer im1 = nbpnts - 1;
+        Standard_Integer im0 = 1;
+        //
+        PClass(im2) = SeqPnt2d.Value(im2);
+        PClass(im1) = SeqPnt2d.Value(im1);
+        PClass(nbpnts) = SeqPnt2d.Value(nbpnts);
+
+        Standard_Real aPer = 0.;
+        for (Standard_Integer ii = 1; ii<nbpnts; ii++, im0++, im1++)
+        {
+          if (im1 >= nbpnts) im1 = 1;
+          PClass(ii) = SeqPnt2d.Value(ii);
+
+          const gp_Pnt2d& aP2D1=PClass(im1);
+          const gp_Pnt2d& aP2D0=PClass(im0);
+          //aP2D0 is next to aP2D1
+          const gp_Vec2d A(PClass(1/*im2*/), aP2D1);
+          const gp_Vec2d B(aP2D1, aP2D0);
+          anArea += A.Crossed(B);
+          aPer += aP2D1.Distance(aP2D0);
+        }//for (Standard_Integer ii = 1; ii<nbpnts; ii++, im0++, im1++)
 
-	      //Standard_Real Baillement2dU=0;
-	      //Standard_Real Baillement2dV=0;
-#if AFFICHAGE
-	      if(nbpnts>1) printf("\nTolVertex %g ",TolVertex);
+#ifdef DEBUG_PCLASS_POLYGON
+        TColStd_Array1OfReal aKnots(1, nbpnts);
+        TColStd_Array1OfInteger aMults(1, nbpnts);
+        for (int i = 1; i <= nbpnts; i++)
+        {
+          aKnots(i) = i;
+          aMults(i) = 1;
+        }
+        aMults(1) = aMults(nbpnts) = 2;
+        Handle(Geom2d_BSplineCurve) aPol = new Geom2d_BSplineCurve(PClass, aKnots, aMults, 1);
+        DrawTrSurf::Set("pol", aPol);
 #endif
 
-	      if(firstpoint==2) u+=du;
-	      Standard_Integer Avant = nbpnts;
-	      for(Standard_Integer e = firstpoint; e<=nbs; e++)
-		{
-		  gp_Pnt2d P2d = C.Value(u);
-		  if(P2d.X()<Umin) Umin = P2d.X();
-		  if(P2d.X()>Umax) Umax = P2d.X();
-		  if(P2d.Y()<Vmin) Vmin = P2d.Y();
-		  if(P2d.Y()>Vmax) Vmax = P2d.Y();
-	  
-		  Standard_Real dist3dptcourant_ancienpnt=1e+20;//RealLast();
-		  gp_Pnt P3d;
-		  if(degenerated==Standard_False)
-		    {
-		      P3d=C3d.Value(u);
-		      if(nbpnts>1 && Ancienpnt3dinitialise) dist3dptcourant_ancienpnt = P3d.Distance(Ancienpnt3d);
-		    }
-		  Standard_Boolean IsRealCurve3d = Standard_True; //patch
-		  if(dist3dptcourant_ancienpnt < Precision::Confusion())
-		    {
-		      gp_Pnt MidP3d = C3d.Value( u-du/2. );
-		      if (P3d.Distance( MidP3d ) < Precision::Confusion()) IsRealCurve3d = Standard_False;
-		    }
-		  if(IsRealCurve3d)
-		    {
-		      if(degenerated==Standard_False) { Ancienpnt3d=P3d;  Ancienpnt3dinitialise=Standard_True; }
-		      nbpnts++;
-		      SeqPnt2d.Append(P2d);
-		    }
-#if AFFICHAGE
-                  else { static int mm=0; printf("\npoint p%d  %g %g %g",++mm,P3d.X(),P3d.Y(),P3d.Z());	}
+        {
+          const Standard_Real aToler = Max(myTol3D, Precision::Confusion());
+          if (Abs(anArea) < aToler*aToler)
+          {
+            // anArea = |A|*|B|*sin(Angle) < Tol*Tol
+            anArea = 0.;
+            BadWire = 1;
+          }
+        }
+
+        if (!BadWire)
+        {
+#ifdef DEBUG_PCLASS_POLYGON
+        TColStd_Array1OfReal aKnots(1, nbpnts);
+        TColStd_Array1OfInteger aMults(1, nbpnts);
+        for (int i = 1; i <= nbpnts; i++)
+        {
+          aKnots(i) = i;
+          aMults(i) = 1;
+        }
+        aMults(1) = aMults(nbpnts) = 2;
+        Handle(Geom2d_BSplineCurve) aPol = new Geom2d_BSplineCurve(PClass, aKnots, aMults, 1);
+        DrawTrSurf::Set("pol", aPol);
 #endif
-		  u+=du;
-		  Standard_Integer ii = nbpnts;
-		  //-- printf("\n nbpnts:%4d  u=%7.5g   FlecheU=%7.5g  FlecheV=%7.5g  ii=%3d  Avant=%3d ",nbpnts,u,FlecheU,FlecheV,ii,Avant);
-// 		  if(ii>(Avant+4))
-//  Modified by Sergey KHROMOV - Fri Apr 19 09:46:12 2002 Begin
-		  if(ii>(Avant+4) && SeqPnt2d(ii-2).SquareDistance(SeqPnt2d(ii)))
-//  Modified by Sergey KHROMOV - Fri Apr 19 09:46:13 2002 End
-		    {
-		      gp_Lin2d Lin(SeqPnt2d(ii-2),gp_Dir2d(gp_Vec2d(SeqPnt2d(ii-2),SeqPnt2d(ii))));
-		      Standard_Real ul = ElCLib::Parameter(Lin,SeqPnt2d(ii-1));
-		      gp_Pnt2d Pp = ElCLib::Value(ul,Lin);
-		      Standard_Real dU = Abs(Pp.X()-SeqPnt2d(ii-1).X());
-		      Standard_Real dV = Abs(Pp.Y()-SeqPnt2d(ii-1).Y());
-		      //-- printf(" (du=%7.5g   dv=%7.5g)",dU,dV);
-		      if(dU>FlecheU) FlecheU = dU;
-		      if(dV>FlecheV) FlecheV = dV;
-		    }
-		}//for(e=firstpoint
-	      if(firstpoint==1) firstpoint=2;
-	      WireIsNotEmpty = Standard_True;
-	    }//if(Or==FORWARD,REVERSED
-	} //-- Edges -> for(Ware.Explorer
-
-      if(NbEdges)
-	{ //-- on compte ++ with a normal explorer and with the Wire Explorer
-/*
-#ifdef OCCT_DEBUG
-
-	  cout << endl;
-	  cout << "*** BRepTopAdaptor_Fclass2d  ** Wire Probablement FAUX **" << endl;
-	  cout << "*** WireExplorer does not find all edges " << endl;
-	  cout << "*** Connect old classifier" << endl;
+
+        Standard_Real anExpThick = Max(2. * Abs(anArea) / aPer, 1e-7);
+        Standard_Real aDefl = Max(FlecheU, FlecheV);
+        Standard_Real aDiscrDefl = Min(aDefl*0.1, anExpThick * 10.);
+        while (aDefl > anExpThick && aDiscrDefl > 1e-7)
+        {
+          // Deflection of the polygon is too much for this ratio of area and perimeter,
+          // and this might lead to self-intersections.
+          // Discretize the wire more tightly to eliminate the error.
+          firstpoint = 1;
+          SeqPnt2d.Clear();
+          FlecheU = 0.0;
+          FlecheV = 0.0;
+          for (aWExp.Init(TopoDS::Wire(aExpF.Current()), myFace);
+            aWExp.More(); aWExp.Next())
+          {
+            edge = aWExp.Current();
+            Or = edge.Orientation();
+            if (Or == TopAbs_FORWARD || Or == TopAbs_REVERSED)
+            {
+              BRep_Tool::Range(edge, myFace, pfbid, plbid);
+              if (Abs(plbid - pfbid) < 1.e-9) continue;
+              BRepAdaptor_Curve2d C(edge, myFace);
+              GCPnts_QuasiUniformDeflection aDiscr(C, aDiscrDefl);
+              if (!aDiscr.IsDone())
+                break;
+              Standard_Integer nbp = aDiscr.NbPoints();
+              Standard_Integer iStep = 1, i = 1, iEnd = nbp + 1;
+              if (Or == TopAbs_REVERSED)
+              {
+                iStep = -1;
+                i = nbp;
+                iEnd = 0;
+              }
+              if (firstpoint == 2)
+                i += iStep;
+              for (; i != iEnd; i += iStep)
+              {
+                gp_Pnt2d aP2d = C.Value(aDiscr.Parameter(i));
+                SeqPnt2d.Append(aP2d);
+              }
+              if (nbp > 2)
+              {
+                Standard_Integer ii = SeqPnt2d.Length();
+                gp_Lin2d Lin(SeqPnt2d(ii - 2), gp_Dir2d(gp_Vec2d(SeqPnt2d(ii - 2), SeqPnt2d(ii))));
+                Standard_Real ul = ElCLib::Parameter(Lin, SeqPnt2d(ii - 1));
+                gp_Pnt2d Pp = ElCLib::Value(ul, Lin);
+                Standard_Real dU = Abs(Pp.X() - SeqPnt2d(ii - 1).X());
+                Standard_Real dV = Abs(Pp.Y() - SeqPnt2d(ii - 1).Y());
+                if (dU > FlecheU) FlecheU = dU;
+                if (dV > FlecheV) FlecheV = dV;
+              }
+              firstpoint = 2;
+            }
+          }
+          nbpnts = SeqPnt2d.Length();
+          PClass.Resize(1, nbpnts, Standard_False);
+          im1 = nbpnts - 1;
+          im0 = 1;
+          PClass(im1) = SeqPnt2d.Value(im1);
+          PClass(nbpnts) = SeqPnt2d.Value(nbpnts);
+          anArea = 0.;
+          aPer = 0.;
+          for (Standard_Integer ii = 1; ii<nbpnts; ii++, im0++, im1++)
+          {
+            if (im1 >= nbpnts) im1 = 1;
+            PClass(ii) = SeqPnt2d.Value(ii);
+            anArea += (PClass(im1).X() - PClass(im0).X())*(PClass(im0).Y() + PClass(im1).Y())*.5;
+            aPer += (PClass(im0).XY() - PClass(im1).XY()).Modulus();
+          }
+#ifdef DEBUG_PCLASS_POLYGON
+          TColStd_Array1OfReal aKnots(1, nbpnts);
+          TColStd_Array1OfInteger aMults(1, nbpnts);
+          for (int i = 1; i <= nbpnts; i++)
+          {
+            aKnots(i) = i;
+            aMults(i) = 1;
+          }
+          aMults(1) = aMults(nbpnts) = 2;
+          Handle(Geom2d_BSplineCurve) aPol = new Geom2d_BSplineCurve(PClass, aKnots, aMults, 1);
+          DrawTrSurf::Set("pol1", aPol);
 #endif
-*/
-	  TColgp_Array1OfPnt2d PClass(1,2);
-	  //// modified by jgv, 28.04.2009 ////
-	  PClass.Init(gp_Pnt2d(0.,0.));
-	  /////////////////////////////////////
-	  TabClass.Append((void *)new CSLib_Class2d(PClass,FlecheU,FlecheV,Umin,Vmin,Umax,Vmax));
-	  BadWire=1;
-	  TabOrien.Append(-1);
-	}
-      else if(WireIsNotEmpty)
-	{
-	  //Standard_Real anglep=0,anglem=0;
-	  TColgp_Array1OfPnt2d PClass(1,nbpnts);
-	  Standard_Real square = 0.0;
-
-	  //-------------------------------------------------------------------
-	  //-- ** The mode of calculation was somewhat changed 
-	  //-- Before Oct 31 97 , the total angle of  
-	  //-- rotation of the wire was evaluated on all angles except for the last 
-	  //-- ** Now, exactly the angle of rotation is evaluated
-	  //-- If a value remote from 2PI or -2PI is found, it means that there is 
-	  //-- an uneven number of loops
-
-	  if(nbpnts>3)
-	    {
-//	      Standard_Integer im2=nbpnts-2;
-	      Standard_Integer im1=nbpnts-1;
-	      Standard_Integer im0=1;
-//	      PClass(im2)=SeqPnt2d.Value(im2);
-	      PClass(im1)=SeqPnt2d.Value(im1);
-	      PClass(nbpnts)=SeqPnt2d.Value(nbpnts);
-
-              Standard_Real aPer = 0.;
-//	      for(Standard_Integer ii=1; ii<nbpnts; ii++,im0++,im1++,im2++)
-	      for(Standard_Integer ii=1; ii<nbpnts; ii++,im0++,im1++)
-		{ 
-//		  if(im2>=nbpnts) im2=1;
-		  if(im1>=nbpnts) im1=1;
-		  PClass(ii)=SeqPnt2d.Value(ii);
-//		  gp_Vec2d A(PClass(im2),PClass(im1));
-//		  gp_Vec2d B(PClass(im1),PClass(im0));
-//		  Standard_Real N = A.Magnitude() * B.Magnitude();
-
-		  square += (PClass(im0).X()-PClass(im1).X())*(PClass(im0).Y()+PClass(im1).Y())*.5; 
-                  aPer += (PClass(im0).XY() - PClass(im1).XY()).Modulus();
-
-//		  if(N>1e-16){ Standard_Real a=A.Angle(B); angle+=a; }
-		}
-
-              Standard_Real anExpThick = Max(2. * Abs(square) / aPer, 1e-7);
-              Standard_Real aDefl = Max(FlecheU, FlecheV);
-              Standard_Real aDiscrDefl = Min(aDefl*0.1, anExpThick * 10.);
-              while (aDefl > anExpThick && aDiscrDefl > 1e-7)
+
+          anExpThick = Max(2. * Abs(anArea) / aPer, 1e-7);
+          aDefl = Max(FlecheU, FlecheV);
+          aDiscrDefl = Min(aDiscrDefl * 0.1, anExpThick * 10.);
+        }
+      }
+        
+        if (!BadWire)
+        {
+          NCollection_Array1<Bnd_B2d> anArrBoxes(1, nbpnts - 1);
+          anArrBoxes(im2).Add(PClass(im2));
+          anArrBoxes(im2).Add(PClass(im1));
+          anArrBoxes(im1).Add(PClass(im1));
+          anArrBoxes(im1).Add(PClass(nbpnts));
+          for (Standard_Integer ii = 1; ii < nbpnts; ii++)
+          {
+            anArrBoxes(ii).Add(PClass(ii));
+            anArrBoxes(ii).Add(PClass(ii + 1));
+          }
+
+          if (nbpnts > 100)
+          {
+            BRepTopAdaptor_FClass2dTree aBBTree;
+            {
+              BRepTopAdaptor_FClass2dTreeFiller aTreeFiller(aBBTree);
+              for (Standard_Integer ii = 1; ii < nbpnts; ii++)
+                aTreeFiller.Add(ii, anArrBoxes(ii));
+            }
+            for (Standard_Integer ii = 1; ii < nbpnts; ii++)
+            {
+              const Bnd_B2d& aBox = anArrBoxes(ii);
+              BRepTopAdaptor_FClass2dSel aSelector(PClass, aBox, ii);
+              if (aBBTree.Select(aSelector))
               {
-                // Deflection of the polygon is too much for this ratio of area and perimeter,
-                // and this might lead to self-intersections.
-                // Discretize the wire more tightly to eliminate the error.
-                firstpoint = 1;
-                SeqPnt2d.Clear();
-                FlecheU = 0.0;
-                FlecheV = 0.0;
-                for (WireExplorer.Init(TopoDS::Wire(FaceExplorer.Current()), Face);
-                  WireExplorer.More(); WireExplorer.Next())
-                {
-                  edge = WireExplorer.Current();
-                  Or = edge.Orientation();
-                  if (Or == TopAbs_FORWARD || Or == TopAbs_REVERSED)
-                  {
-                    Standard_Real pfbid, plbid;
-                    BRep_Tool::Range(edge, Face, pfbid, plbid);
-                    if (Abs(plbid - pfbid) < 1.e-9) continue;
-                    BRepAdaptor_Curve2d C(edge, Face);
-                    GCPnts_QuasiUniformDeflection aDiscr(C, aDiscrDefl);
-                    if (!aDiscr.IsDone())
-                      break;
-                    Standard_Integer nbp = aDiscr.NbPoints();
-                    Standard_Integer iStep = 1, i = 1, iEnd = nbp + 1;
-                    if (Or == TopAbs_REVERSED)
-                    {
-                      iStep = -1;
-                      i = nbp;
-                      iEnd = 0;
-                    }
-                    if (firstpoint == 2)
-                      i += iStep;
-                    for (; i != iEnd; i += iStep)
-                    {
-                      gp_Pnt2d aP2d = C.Value(aDiscr.Parameter(i));
-                      SeqPnt2d.Append(aP2d);
-                    }
-                    if (nbp > 2)
-                    {
-                      Standard_Integer ii = SeqPnt2d.Length();
-                      gp_Lin2d Lin(SeqPnt2d(ii - 2), gp_Dir2d(gp_Vec2d(SeqPnt2d(ii - 2), SeqPnt2d(ii))));
-                      Standard_Real ul = ElCLib::Parameter(Lin, SeqPnt2d(ii - 1));
-                      gp_Pnt2d Pp = ElCLib::Value(ul, Lin);
-                      Standard_Real dU = Abs(Pp.X() - SeqPnt2d(ii - 1).X());
-                      Standard_Real dV = Abs(Pp.Y() - SeqPnt2d(ii - 1).Y());
-                      if (dU > FlecheU) FlecheU = dU;
-                      if (dV > FlecheV) FlecheV = dV;
-                    }
-                    firstpoint = 2;
-                  }
-                }
-                nbpnts = SeqPnt2d.Length();
-                PClass.Resize(1, nbpnts, Standard_False);
-                im1 = nbpnts - 1;
-                im0 = 1;
-                PClass(im1) = SeqPnt2d.Value(im1);
-                PClass(nbpnts) = SeqPnt2d.Value(nbpnts);
-                square = 0.;
-                aPer = 0.;
-                for (Standard_Integer ii = 1; ii<nbpnts; ii++, im0++, im1++)
+                //The polygon is self-intersected
+                BadWire = Standard_True;
+                break;
+              }
+            }
+          }
+          else
+          {
+            for (Standard_Integer ii = 1; ii < nbpnts; ii++)
+            {
+              const Bnd_B2d& aBox = anArrBoxes(ii);
+              BRepTopAdaptor_FClass2dSel aSelector(PClass, aBox, ii);
+              for (Standard_Integer j = ii + 1; j < nbpnts; j++)
+              {
+                const Bnd_B2d& aBoxj = anArrBoxes(j);
+                if (!aSelector.Reject(aBoxj) && aSelector.Accept(j))
                 {
-                  if (im1 >= nbpnts) im1 = 1;
-                  PClass(ii) = SeqPnt2d.Value(ii);
-                  square += (PClass(im0).X() - PClass(im1).X())*(PClass(im0).Y() + PClass(im1).Y())*.5;
-                  aPer += (PClass(im0).XY() - PClass(im1).XY()).Modulus();
+                  //The polygon is self-intersected
+                  BadWire = Standard_True;
+                  break;
                 }
-
-                anExpThick = Max(2. * Abs(square) / aPer, 1e-7);
-                aDefl = Max(FlecheU, FlecheV);
-                aDiscrDefl = Min(aDiscrDefl * 0.1, anExpThick * 10.);
               }
-      
-	      //-- FlecheU*=10.0;
-	      //-- FlecheV*=10.0;
-	      if(FlecheU<Toluv) FlecheU = Toluv;
-	      if(FlecheV<Toluv) FlecheV = Toluv;
-	      //-- cout<<" U:"<<FlecheU<<" V:"<<FlecheV<<endl;
-	      TabClass.Append((void *)new CSLib_Class2d(PClass,FlecheU,FlecheV,Umin,Vmin,Umax,Vmax));
-
-//	      if((angle<2 && angle>-2)||(angle>10)||(angle<-10))
-//		{
-//		  BadWire=1;
-//		  TabOrien.Append(-1);
-//#ifdef OCCT_DEBUG
-//		  cout << endl;
-//		  cout << "*** BRepTopAdaptor_Fclass2d  ** Wire Probably FALSE **" << endl;
-//		  cout << "*** Total rotation angle of the wire : " << angle << endl;
-//		  cout << "*** Connect the old classifier" << endl;
-//#endif
-//		} 
-//	      else TabOrien.Append(((angle>0.0)? 1 : 0));
-	      TabOrien.Append(((square < 0.0)? 1 : 0));
-	    }//if(nbpoints>3
-	  else
-	    { 
-#ifdef OCCT_DEBUG
-	      cout << endl;
-	      cout << "*** BRepTopAdaptor_Fclass2d  ** Wire Probably FALSE **" << endl;
-	      cout << "*** The sample wire contains less than 3 points" << endl;
-	      cout << "*** Connect the old classifier" << endl;
-#endif       
-	      BadWire=1;
-	      TabOrien.Append(-1);
-	      TColgp_Array1OfPnt2d xPClass(1,2);
-	      xPClass(1) = SeqPnt2d(1); 
-	      xPClass(2) = SeqPnt2d(2);
-	      TabClass.Append((void *)new CSLib_Class2d(xPClass,FlecheU,FlecheV,Umin,Vmin,Umax,Vmax));
-	    }
-	}//else if(WareIsNotEmpty
-  }//for(FaceExplorer
-
-  Standard_Integer nbtabclass = TabClass.Length();
-
-  if(nbtabclass>0)
-    {
-      //-- If an error was detected on a wire: set all TabOrien to -1
-      if(BadWire) TabOrien(1)=-1;
-
-      if(   surf->GetType()==GeomAbs_Cone
-	 || surf->GetType()==GeomAbs_Cylinder
-	 || surf->GetType()==GeomAbs_Torus
-	 || surf->GetType()==GeomAbs_Sphere
-	 || surf->GetType()==GeomAbs_SurfaceOfRevolution)
-	
-	{
-	  Standard_Real uuu=M_PI+M_PI-(Umax-Umin);
-	  if(uuu<0) uuu=0;
-	  U1 = 0.0;  // modified by NIZHNY-OFV  Thu May 31 14:24:10 2001 ---> //Umin-uuu*0.5;
-	  U2 = 2*M_PI; // modified by NIZHNY-OFV  Thu May 31 14:24:35 2001 ---> //U1+M_PI+M_PI;
-	}
-      else { U1=U2=0.0; } 
-    
-      if(surf->GetType()==GeomAbs_Torus)
-	{ 
-	  Standard_Real uuu=M_PI+M_PI-(Vmax-Vmin);
-	  if(uuu<0) uuu=0;
-	  V1 = 0.0;  // modified by NIZHNY-OFV  Thu May 31 14:24:55 2001 ---> //Vmin-uuu*0.5;
-	  V2 = 2*M_PI; // modified by NIZHNY-OFV  Thu May 31 14:24:59 2001 ---> //V1+M_PI+M_PI;
-	}
-      else { V1=V2=0.0; }   
-    }
-}
+            }
+          }
+        } // if (!BadWire) cond.
+      } // if (!BadWire) cond.
 
-TopAbs_State BRepTopAdaptor_FClass2d::PerformInfinitePoint() const { 
-#if LBRCOMPT 
-  STAT.NbPerformInfinitePoint++;
-#endif
-  
-  if(Umax==-RealLast() || Vmax==-RealLast() || Umin==RealLast() || Vmin==RealLast()) { 
-    return(TopAbs_IN);
+      if (!BadWire)
+      {
+        myTabClass.Append(new CSLib_Class2d(PClass,
+                                            FlecheU, FlecheV,
+                                            myUmin, myVmin, myUmax, myVmax));
+
+        myTabOrien.Append((anArea > 0.0) ? 1 : 0);
+      }
+      else // if (BadWire)
+      {
+        myTabOrien.Append(-1);
+        TColgp_Array1OfPnt2d PPClass(1, 2);
+        myTabClass.Append(new CSLib_Class2d(PPClass,
+                                            FlecheU,
+                                            FlecheV,
+                                            myUmin, myVmin, myUmax, myVmax));
+      }
+    }// else if(!WireIsEmpty) cond.
+  } // for(; aExpF.More();  aExpF.Next()) {
+
+  if((myTabClass.Length() > 0) && (BadWire))
+  {
+    //-- if an error on a wire was detected : all TabOrien set to -1
+    myTabOrien(1) = -1;
   }
-  gp_Pnt2d P(Umin-(Umax-Umin),Vmin-(Vmax-Vmin));
-  return(Perform(P,Standard_False));
 }
 
-TopAbs_State BRepTopAdaptor_FClass2d::Perform(const gp_Pnt2d& _Puv,
-					      const Standard_Boolean RecadreOnPeriodic) const
-{ 
-#if LBRCOMPT 
-  STAT.NbPerform++;
-#endif
-  
-  Standard_Integer dedans;
-  Standard_Integer nbtabclass = TabClass.Length();
-  
-  if(nbtabclass==0) { 
-    return(TopAbs_IN);
+//=======================================================================
+//function : PerformInfinitePoint
+//purpose  : 
+//=======================================================================
+TopAbs_State BRepTopAdaptor_FClass2d::PerformInfinitePoint() const
+{
+  if(myUmax == -RealLast() || myVmax == -RealLast() ||
+     myUmin == RealLast() || myVmin == RealLast())
+  {
+    return TopAbs_IN;
   }
-  
-  //-- U1 is the First Param and U2 in this case is U1+Period
-  Standard_Real u=_Puv.X();
-  Standard_Real v=_Puv.Y();
-  Standard_Real uu = u, vv = v;
-
-  Handle(BRepAdaptor_HSurface) surf = new BRepAdaptor_HSurface();
-  surf->ChangeSurface().Initialize( Face, Standard_False );
-  const Standard_Boolean IsUPer  = surf->IsUPeriodic();
-  const Standard_Boolean IsVPer  = surf->IsVPeriodic();
-  const Standard_Real    uperiod = IsUPer ? surf->UPeriod() : 0.0;
-  const Standard_Real    vperiod = IsVPer ? surf->VPeriod() : 0.0;
-  TopAbs_State aStatus = TopAbs_UNKNOWN;
-  Standard_Boolean urecadre = Standard_False, vrecadre = Standard_False;
 
-  if (RecadreOnPeriodic)
+  const Standard_Real aMaxTol = Min(10.0, BRep_Tool::MaxTolerance(myFace,
+                                                                  TopAbs_VERTEX));
+  const BRepAdaptor_Surface aS(myFace, Standard_False);
+  gp_Pnt2d aP;
+
+  // For periodic surfaces, Umax - Umin (or Vmax - Vmin)
+  // can be equal to period. In this case, shift on 
+  // k*(Umax - Umin), where k is an integer number,
+  // will not take any effect in 3D-space. Therefore, we apply
+  // that k is not integer.
+  const Standard_Real aDeltaU = 1.5*(myUmax - myUmin),
+                      aDeltaV = 1.5*(myVmax - myVmin);
+
+  if (aDeltaU < aDeltaV)
+  {
+    aP.SetCoord((myUmin - Max(aDeltaU + 2.0*aS.UResolution(aMaxTol), 1.0)),
+                                                        0.5*(myVmax + myVmin));
+
+    //In order to avoid work with infinite-located curves (e.g. in
+    //half-spaces)
+    if(Precision::IsInfinite(myVmax) && Precision::IsInfinite(myVmin))
+    {
+      aP.SetY(0.0);
+    }
+    else if(Precision::IsInfinite(myVmax))
     {
-      if (IsUPer)
-	{
-	  if (uu < Umin)
-	    while (uu < Umin)
-	      uu += uperiod;
-	  else
-	    {
-	      while (uu >= Umin)
-		uu -= uperiod;
-	      uu += uperiod;
-	    }
-	}
-      if (IsVPer)
-	{
-	  if (vv < Vmin)
-	    while (vv < Vmin)
-	      vv += vperiod;
-	  else
-	    {
-	      while (vv >= Vmin)
-		vv -= vperiod;
-	      vv += vperiod;
-	    }
-	}
+      aP.SetY(myVmin - 100.0*aS.VResolution(aMaxTol));
     }
+    else if(Precision::IsInfinite(myVmin))
+    {
+      aP.SetY(myVmax + 100.0*aS.VResolution(aMaxTol));
+    }
+  }
+  else
+  {
+    aP.SetCoord(0.5*(myUmax + myUmin),
+                    (myVmin - Max(aDeltaV + 2.0*aS.VResolution(aMaxTol), 1.0)));
 
-  for (;;)
+    //In order to avoid work with infinite-located curves (e.g. in
+    //half-spaces)
+    if(Precision::IsInfinite(myUmax) && Precision::IsInfinite(myUmin))
     {
-      dedans = 1;
-      gp_Pnt2d Puv(u,v);
-      
-      if(TabOrien(1)!=-1) { 
-	for(Standard_Integer n=1; n<=nbtabclass; n++) { 
-	  Standard_Integer cur = ((CSLib_Class2d *)TabClass(n))->SiDans(Puv);
-	  if(cur==1) { 
-	    if(TabOrien(n)==0) { 
-	      dedans = -1; 
-	      break;
-	    }
-	  }
-	  else if(cur==-1) { 
-	    if(TabOrien(n)==1) {  
-	      dedans = -1; 
-	      break;
-	    }
-	  }
-	  else { 
-	    dedans = 0;
-	    break;
-	  }
-	}
-	if(dedans==0) { 
-	  BRepClass_FaceClassifier aClassifier;
-	  Standard_Real m_Toluv = (Toluv > 4.0) ? 4.0 : Toluv;
-	  //aClassifier.Perform(Face,Puv,Toluv);
-	  aClassifier.Perform(Face,Puv,m_Toluv);
-	  aStatus = aClassifier.State();
-	}
-	if(dedans == 1) { 
-	  aStatus = TopAbs_IN;
-	}
-	if(dedans == -1) {
-	  aStatus = TopAbs_OUT;
-	}
-      }
-      else {  //-- TabOrien(1)=-1    False Wire
-	BRepClass_FaceClassifier aClassifier;
-	aClassifier.Perform(Face,Puv,Toluv);
-	aStatus = aClassifier.State();
-      }
+      aP.SetX(0.0);
+    }
+    else if(Precision::IsInfinite(myUmax))
+    {
+      aP.SetX(myUmin - 100.0*aS.UResolution(aMaxTol));
+    }
+    else if(Precision::IsInfinite(myUmin))
+    {
+      aP.SetX(myUmax + 100.0*aS.UResolution(aMaxTol));
+    }
+  }
 
-      if (!RecadreOnPeriodic || (!IsUPer && !IsVPer))
-	return aStatus;
-      if (aStatus == TopAbs_IN || aStatus == TopAbs_ON)
-	return aStatus;
+#ifdef BREPTOPADAPTOR_FCLASS2D_DEBUG
+  std::cout << "BRepTopAdaptor_FClass2d::PerformInfinitePoint: point " << 
+                                            aP.X() << " " << aP.Y() << std::endl;
+#endif
 
-      if (!urecadre)
-	{
-	  u = uu;
-	  urecadre = Standard_True;
-	}
-      else
-	if (IsUPer)
-	  u += uperiod;
-      if (u > Umax || !IsUPer)
-	{
-	  if (!vrecadre)
-	    {
-	      v = vv;
-	      vrecadre = Standard_True;
-	    }
-	  else
-	    if (IsVPer)
-	      v += vperiod;
-
-	  u = uu;
-
-	  if (v > Vmax || !IsVPer)
-	    return aStatus;
-	}
-    } //for (;;)
+  return (Perform(aP, Standard_False));
 }
 
-TopAbs_State BRepTopAdaptor_FClass2d::TestOnRestriction(const gp_Pnt2d& _Puv,
-							const Standard_Real Tol,
-							const Standard_Boolean RecadreOnPeriodic) const
+//=======================================================================
+//function : Perform
+//purpose  : 
+//=======================================================================
+TopAbs_State 
+        BRepTopAdaptor_FClass2d::Perform(const gp_Pnt2d& theP2D,
+                                         const Standard_Boolean theIsReqToAdjust) const
 { 
-#if LBRCOMPT 
-  STAT.NbConstrShape++;
-#endif
-  
-  Standard_Integer dedans;
-  Standard_Integer nbtabclass = TabClass.Length();
-  
-  if(nbtabclass==0) { 
-    return(TopAbs_IN);
+  const Standard_Integer aNbTabClass = myTabClass.Length();
+  if(aNbTabClass == 0)
+  {
+    return TopAbs_IN;
   }
-  
-  //-- U1 is the First Param and U2 in this case is U1+Period
-  Standard_Real u=_Puv.X();
-  Standard_Real v=_Puv.Y();
-  Standard_Real uu = u, vv = v;
-  
-  Handle(BRepAdaptor_HSurface) surf = new BRepAdaptor_HSurface();
-  surf->ChangeSurface().Initialize( Face, Standard_False );
-  const Standard_Boolean IsUPer  = surf->IsUPeriodic();
-  const Standard_Boolean IsVPer  = surf->IsVPeriodic();
-  const Standard_Real    uperiod = IsUPer ? surf->UPeriod() : 0.0;
-  const Standard_Real    vperiod = IsVPer ? surf->VPeriod() : 0.0;
+
+  Standard_Real aU = theP2D.X();
+  Standard_Real aV = theP2D.Y();
+  Standard_Real aUprev = aU;
+  Standard_Real aVprev = aV;
   TopAbs_State aStatus = TopAbs_UNKNOWN;
-  Standard_Boolean urecadre = Standard_False, vrecadre = Standard_False;
-  
-  if (RecadreOnPeriodic)
+
+  const BRepAdaptor_Surface anAS(myFace, Standard_False);
+
+  const Standard_Boolean IsUPer = anAS.IsUPeriodic();
+  const Standard_Boolean IsVPer = anAS.IsVPeriodic();
+  const Standard_Real    aUperiod = IsUPer ? anAS.UPeriod() : 0.0;
+  const Standard_Real    aVperiod = IsVPer ? anAS.VPeriod() : 0.0;
+
+  Standard_Boolean isUAdjusted = Standard_False, 
+                   isVAdjusted = Standard_False;
+  Standard_Integer aTmpStatus = 1;
+  //
+  if (theIsReqToAdjust) {
+    Standard_Real aDU, aDV;
+    if (IsUPer) {
+      GeomInt::AdjustPeriodic(aUprev, myUmin, myUmax, aUperiod, aUprev, aDU);
+    }// if (IsUPer) {
+    //
+    if (IsVPer) {
+      GeomInt::AdjustPeriodic(aVprev, myVmin, myVmax, aVperiod, aVprev, aDV);
+    }//if (IsVPer) {
+  }
+  //
+  for (;;) {
+    aTmpStatus = 1;
+    gp_Pnt2d aPuv(aU, aV);
+
+#ifdef BREPTOPADAPTOR_FCLASS2D_CheckPolygon
+    const Standard_Boolean hasToUseClassifier = Standard_False;
+#else
+    Standard_Boolean hasToUseClassifier = (myTabOrien(1) == -1);
+#endif
+
+    if(!hasToUseClassifier)
+    {
+      for(Standard_Integer aN = 1; aN <= aNbTabClass; aN++)
+      {
+        const Standard_Integer aPolyStatus = myTabClass(aN)->Classify(aPuv);
+        const Standard_Integer aTabOri = myTabOrien(aN);
+        if(aPolyStatus == 1)
+        {
+          if(aTabOri == 0)
+          {
+            aTmpStatus = -1;
+            break;
+          }
+        }
+        else if(aPolyStatus == -1)
+        {
+          if(aTabOri == 1)
+          {
+            aTmpStatus = -1;
+            break;
+          }
+        }
+        else {
+          aTmpStatus = 0;
+          break;
+        }
+      } // for(n=1; n<=nbtabclass; n++)
+
+      if(aTmpStatus == 0)
+      {
+#if BREPTOPADAPTOR_FCLASS2D_CheckPolygon
+        aStatus = TopAbs_ON;
+#else
+        hasToUseClassifier = Standard_True;
+#endif
+      }
+      else
+      {
+        aStatus = (aTmpStatus == 1) ? TopAbs_IN : TopAbs_OUT;
+      }
+    } // if(TabOrien(1)!=-1) {
+    //compute state of the point using face classifier
+    if(hasToUseClassifier)
     {
-      if (IsUPer)
-	{
-	  if (uu < Umin)
-	    while (uu < Umin)
-	      uu += uperiod;
-	  else
-	    {
-	      while (uu >= Umin)
-		uu -= uperiod;
-	      uu += uperiod;
-	    }
-	}
-      if (IsVPer)
-	{
-	  if (vv < Vmin)
-	    while (vv < Vmin)
-	      vv += vperiod;
-	  else
-	    {
-	      while (vv >= Vmin)
-		vv -= vperiod;
-	      vv += vperiod;
-	    }
-	}
+      myClassifier.Perform(myFace, aPuv, myTol3D);
+      aStatus = myClassifier.State();
     }
-  
-  for (;;)
+
+    if (!theIsReqToAdjust || (!IsUPer && !IsVPer))
+      return aStatus;
+    
+    if (aStatus == TopAbs_IN || aStatus == TopAbs_ON)
+      return aStatus;
+    
+    if(!isUAdjusted)
     {
-      dedans = 1;
-      gp_Pnt2d Puv(u,v);
-      
-      if(TabOrien(1)!=-1) { 
-	for(Standard_Integer n=1; n<=nbtabclass; n++) { 
-	  Standard_Integer cur = ((CSLib_Class2d *)TabClass(n))->SiDans_OnMode(Puv,Tol);
-	  if(cur==1) { 
-	    if(TabOrien(n)==0) { 
-	      dedans = -1; 
-	      break;
-	    }
-	  }
-	  else if(cur==-1) { 
-	    if(TabOrien(n)==1) {  
-	      dedans = -1; 
-	      break;
-	    }
-	  }
-	  else { 
-	    dedans = 0;
-	    break;
-	  }
-	}
-	if(dedans==0) {
-	  aStatus = TopAbs_ON;
-	}
-	if(dedans == 1) {
-	  aStatus = TopAbs_IN;
-	}
-	if(dedans == -1) {
-	  aStatus = TopAbs_OUT;
-	}
+      aU = aUprev;
+      isUAdjusted = Standard_True;
+    }
+    else {
+      if (IsUPer){
+        aU += aUperiod;
       }
-      else {  //-- TabOrien(1)=-1    False Wire
-	BRepClass_FaceClassifier aClassifier;
-	aClassifier.Perform(Face,Puv,Tol);
-	aStatus = aClassifier.State();
+    }
+
+    if(aU > myUmax || !IsUPer)
+    {
+      if(!isVAdjusted)
+      {
+        aV = aVprev;
+        isVAdjusted = Standard_True;
       }
+      else {
+        if (IsVPer){
+          aV += aVperiod;
+        }
+      }
+
+      aU = aUprev;
       
-      if (!RecadreOnPeriodic || (!IsUPer && !IsVPer))
-	return aStatus;
-      if (aStatus == TopAbs_IN || aStatus == TopAbs_ON)
-	return aStatus;
-      
-      if (!urecadre)
-	{
-	  u = uu;
-	  urecadre = Standard_True;
-	}
-      else
-	if (IsUPer)
-	  u += uperiod;
-      if (u > Umax || !IsUPer)
-	{
-	  if (!vrecadre)
-	    {
-	      v = vv;
-	      vrecadre = Standard_True;
-	    }
-	  else
-	    if (IsVPer)
-	      v += vperiod;
-	  
-	  u = uu;
-	  
-	  if (v > Vmax || !IsVPer)
-	    return aStatus;
-	}
-    } //for (;;)
+      if(aV > myVmax || !IsVPer)
+      {
+        return aStatus;
+      }
+    }
+  } //while (1)
 }
 
+//=======================================================================
+//function : TestOnRestriction
+//purpose  : 
+//=======================================================================
+TopAbs_State 
+BRepTopAdaptor_FClass2d::TestOnRestriction(const gp_Pnt2d& theP2D,
+                                           const Standard_Real theTol3D,
+                                           const Standard_Boolean theIsReqToAdjust) const
+{ 
+  const Standard_Integer aNbTabClass = myTabClass.Length();
+  if(aNbTabClass == 0)
+  {
+    return TopAbs_IN;
+  }
+
+  Standard_Real aU = theP2D.X();
+  Standard_Real aV = theP2D.Y();
+  Standard_Real aUprev = aU;
+  Standard_Real aVprev = aV;
+  TopAbs_State aStatus = TopAbs_UNKNOWN;
+
+  const BRepAdaptor_Surface anAS(myFace, Standard_False);
+  const Standard_Real aURes = anAS.UResolution(theTol3D),
+                      aVRes = anAS.VResolution(theTol3D);
+
+  const Standard_Boolean IsUPer = anAS.IsUPeriodic();
+  const Standard_Boolean IsVPer = anAS.IsVPeriodic();
+  const Standard_Real    aUperiod = IsUPer ? anAS.UPeriod() : 0.0;
+  const Standard_Real    aVperiod = IsVPer ? anAS.VPeriod() : 0.0;
 
-void BRepTopAdaptor_FClass2d::Destroy() { 
-#if LBRCOMPT
-  STAT.NbDestroy++;
+  Standard_Boolean isUAdjusted = Standard_False,
+    isVAdjusted = Standard_False;
+  Standard_Integer aTmpStatus = 1;
+  //
+  if(theIsReqToAdjust)
+  {
+    Standard_Real aDU, aDV;
+    if(IsUPer)
+    {
+      GeomInt::AdjustPeriodic(aUprev, myUmin, myUmax, aUperiod, aUprev, aDU);
+    }// if (IsUPer) {
+    //
+    if(IsVPer)
+    {
+      GeomInt::AdjustPeriodic(aVprev, myVmin, myVmax, aVperiod, aVprev, aDV);
+    }//if (IsVPer) {
+  }
+  //
+  for(;;)
+  {
+    aTmpStatus = 1;
+    gp_Pnt2d aPuv(aU, aV);
+
+#ifdef BREPTOPADAPTOR_FCLASS2D_CheckPolygon
+    const Standard_Boolean bUseClassifier = Standard_False;
+#else
+    Standard_Boolean hasToUseClassifier = (myTabOrien(1) == -1);
 #endif
-  
-  Standard_Integer nbtabclass = TabClass.Length(); 
-  for(Standard_Integer d=1; d<=nbtabclass;d++) {
-    if(TabClass(d)) { 
-      delete ((CSLib_Class2d *)TabClass(d));
-      TabClass(d)=NULL;
+
+    if(!hasToUseClassifier)
+    {
+      for(Standard_Integer aN = 1; aN <= aNbTabClass; aN++)
+      {
+        const Standard_Integer aPolyStatus = myTabClass(aN)->Classify(aPuv, aURes, aVRes);
+        const Standard_Integer aTabOri = myTabOrien(aN);
+        if(aPolyStatus == 1)
+        {
+          if(aTabOri == 0)
+          {
+            aTmpStatus = -1;
+            break;
+          }
+        }
+        else if(aPolyStatus == -1)
+        {
+          if(aTabOri == 1)
+          {
+            aTmpStatus = -1;
+            break;
+          }
+        }
+        else
+        {
+          aTmpStatus = 0;
+          break;
+        }
+      } // for(n=1; n<=nbtabclass; n++)
+
+      if(aTmpStatus == 0)
+      {
+#if BREPTOPADAPTOR_FCLASS2D_CheckPolygon
+        aStatus = TopAbs_ON;
+#else
+        hasToUseClassifier = Standard_True;
+#endif
+      }
+      else
+      {
+        aStatus = (aTmpStatus == 1) ? TopAbs_IN : TopAbs_OUT;
+      }
+    } // if(TabOrien(1)!=-1) {
+    //compute state of the point using face classifier
+    if(hasToUseClassifier)
+    {
+      myClassifier.Perform(myFace, aPuv, theTol3D);
+      aStatus = myClassifier.State();
     }
-  }
-}
 
+    if(!theIsReqToAdjust || (!IsUPer && !IsVPer))
+      return aStatus;
 
+    if(aStatus == TopAbs_IN || aStatus == TopAbs_ON)
+      return aStatus;
 
-#include <Standard_ConstructionError.hxx>
+    if(!isUAdjusted)
+    {
+      aU = aUprev;
+      isUAdjusted = Standard_True;
+    }
+    else
+    {
+      if(IsUPer)
+      {
+        aU += aUperiod;
+      }
+    }
 
+    if(aU > myUmax || !IsUPer)
+    {
+      if(!isVAdjusted)
+      {
+        aV = aVprev;
+        isVAdjusted = Standard_True;
+      }
+      else
+      {
+        if(IsVPer)
+        {
+          aV += aVperiod;
+        }
+      }
 
-//const BRepTopAdaptor_FClass2d &  BRepTopAdaptor_FClass2d::Copy(const BRepTopAdaptor_FClass2d& Other) const { 
-const BRepTopAdaptor_FClass2d &  BRepTopAdaptor_FClass2d::Copy(const BRepTopAdaptor_FClass2d& ) const { 
-#ifdef OCCT_DEBUG
-  cerr<<"Copy not allowed in BRepTopAdaptor_FClass2d"<<endl;
-#endif
-  throw Standard_ConstructionError();
+      aU = aUprev;
+
+      if(aV > myVmax || !IsVPer)
+      {
+        return aStatus;
+      }
+    }
+  } //while (1)
 }
+
+//=======================================================================
+//function : Destroy
+//purpose  : 
+//=======================================================================
+void BRepTopAdaptor_FClass2d::Destroy()
+{
+  Standard_Integer nbtabclass = myTabClass.Length();
+  for (Standard_Integer d = 1; d <= nbtabclass; d++)
+  {
+    if(myTabClass(d))
+    {
+      delete myTabClass(d);
+    }
+  }
+
+  myTabClass.Clear();
+  myTabOrien.Clear();
+}
\ No newline at end of file
